/*[*//***************************************************************************
% NAME MALIv06                        file : FILE_NAME
%
%     AUTHOR
%          INRIA, Domaine de Voluceau-Rocquencourt, BP 105, 78153 LE CHESNAY Cedex, FRANCE
%          Tlx: 697 033 F, Fax: (33) (1) 39 63 53 30, Phone: (33) (1) 39 63 55 11
%
%          This software has been designed and programmed by Olivier Ridoux 
%          at IRISA.  For further information or comments, e-mail to
%          maliv06@irisa.fr
%          or write to
%          IRISA, Campus Universitaire de Beaulieu, 35042 RENNES Cedex, FRANCE
%          Tlx: Unirisa 950 473 F, Fax: (33) 99 38 38 32, Phone: (33) 99 84 71 00
%
%     COPYRIGHT
%          Both this software, named MALIv06, and its documentation are
%
%              Copyrighted 1992 by INRIA, all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : LICENSING).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and neither IRISA nor INRIA are affiliated with that organization.
%**************************************************************************//*]*/

#define MALImachine "sun4"
#define MALIversion "06"


typedef  unsigned char  T_NATURE;

typedef  unsigned long  T_SORT;

typedef   unsigned long  T_INDIC;

typedef  int  T_XCEP;

typedef  struct _T_CELL *  T_INFO;

typedef struct  _T_CELL { T_INDIC indic; T_INFO info; } T_CELL;

typedef  struct _T_CELL *  T_ROBJ;

typedef T_CELL T_CELLO;

typedef T_CELL T_SPACE ;

typedef struct _T_PAGE
{ struct
  { struct _T_PAGE       * prev ;
    long                 tbytes, tcells, tpages ;
  }                                              dyn;
  struct
  { long               nbytes, ncells ;
    T_ROBJ             space, end_of_space ;
  }                                              stat;
} T_PAGE ;

typedef struct 
{ T_PAGE                 * used_pages, * free_pages ;
  T_ROBJ               alloc, end_of_space, stacklike_space ;
  int        all_stacklike;
} T_ALLOC ;

typedef struct
        { T_CELL 
                trail ;
        } T_UNBIND_OLD; 
typedef struct
        { T_CELL 
                top_level;    
          T_CELLO * 
                ref_end_trail; 
        } T_UNBIND_NEW;

typedef struct 
        { T_CELL 
                      trail,
                
                      top_level;   
        } T_DEVAR_OLD;  
typedef struct
        { T_CELL 
                      top_level,
                
                      trail;
       } T_DEVAR_NEW;

extern

T_ALLOC allocV ;

extern

struct 
{ void       (*exception)() ; 
  T_XCEP      current_overflow_code;
} xcepV;

extern

struct 
{ T_CELL copied_weak_terms;
  T_CELL used_strong_terms;

  T_CELL unused_strong_terms;
} useV;

extern

struct 
{ T_CELL top_level ;          
  T_ROBJ  obj_bottom_level;    
  T_CELLO  * obj_rec_level;    

  T_CELL trail         ;       
  T_CELL   ghost_level ;       
} rarrV;

extern

struct
{ int         niv_fantome ;
  char                  trace[128];
  char                  xcep[128];
  char                  cell2s[128];
  char                  message[128];
  char ** 
           ref_output ;
  int         trace_on ;
  
  struct 
  { struct
    { struct
      { long                unbind, devar, rd, rd_tot ;
      }                     shunt ;
      struct
      { long                gc, as ;
      }                     set ;
    }                     constr ;
    struct
    { struct 
      { long                  cons0, mcons0, cons1, mcons1, cons2, mcons2, 
                              cons3, mcons3, tuple, mtuple, level, data, mdata,
                              weak, strong; 
      }                     mk, rd ;
      struct
      { long                  push, pop, as, as_top, gt ;
      }                     ss ; 
      struct
      { long                  cell, atom ;
      }                     st ;
      struct
      { long                  cell ;
      }                     eq ;
    }                     nb_calls ;
    struct
    { struct T_DISTR
      { long                d[(100)+2]; 
      }                     mut_ref, level_ref, 
                            tuple_size, mtuple_size, data_size, mdata_size,
                            trail_chunk ;
    }                     distr ;
  }                     stat ;
} dbugV ;

 

 

 

 

 

  

  

#define TUPLE_MAX_SIZE  ( allocV.used_pages->stat.ncells ) 
#define TUPLE_MIN_SIZE              1

#define DATA_MAX_SIZE  ( allocV.used_pages->stat.ncells ) 
#define DATA_MIN_SIZE              1

#define CONS_SELECT_1ST( objcons ) ((T_CELLO*)(objcons))
#define CONS_SELECT_2ND( objcons ) (((T_CELLO*)(objcons))+1)
#define CONS_SELECT_3RD( objcons ) (((T_CELLO*)(objcons))+2)

#define TUPLE_SELECT_ITH( objcons, index ) (((T_CELLO*)(objcons))+(index))

#define TUPLE_GET_SIZE( objcons ) (*(long*)&( (objcons)->info ))

#define DATA_SELECT_VALUE( objdata   ) ((char*)(objdata+1))

#define DATA_GET_SIZE( objdata   ) (*(long*)&( (objdata)->info ))

#define CONS_SHIFT_RIGHT( component ) ( (component)+1 )
#define CONS_SHIFT_LEFT(  component ) ( (component)-1 )

#define TUPLE_SHIFT( component, shift ) ((component)+(shift))

 

#define MK_CONS0(  Sort,   Ref      ) { MK_CONS0i(Sort,Ref); }
#define MK_MCONS0( Sort,   Ref      ) { MK_MCONS0i(Sort,Ref); }

 

#define MK_CONS1(  Sort,   Ref,      Obj         ) { MK_CONS1i(Sort,Ref,&(Obj)); }
#define MK_MCONS1( Sort,   Ref,      Obj         ) { MK_MCONS1i(Sort,Ref,&(Obj)); }
#define MK_CONS2(  Sort,   Ref,      Obj         ) { MK_CONS2i(Sort,Ref,&(Obj)); }
#define MK_MCONS2( Sort,   Ref,      Obj         ) { MK_MCONS2i(Sort,Ref,&(Obj)); }
#define MK_CONS3(  Sort,   Ref,      Obj         ) { MK_CONS3i(Sort,Ref,&(Obj)); }
#define MK_MCONS3( Sort,   Ref,      Obj         ) { MK_MCONS3i(Sort,Ref,&(Obj)); }

 

#define MK_TUPLE(  Sort,   Ref,      Obj,         Size ) { MK_TUPLEi(Sort,Ref,&(Obj),Size); }
#define MK_MTUPLE( Sort,   Ref,      Obj,         Size ) { MK_MTUPLEi(Sort,Ref,&(Obj),Size); }

#define RD_CONS1( Ref,      Obj         ) { RD_CONS1i(Ref,&(Obj)); }
#define RD_CONS2( Ref,      Obj         ) { RD_CONS2i(Ref,&(Obj)); }
#define RD_CONS3( Ref,      Obj         ) { RD_CONS3i(Ref,&(Obj)); }
#define RD_TUPLE( Ref,      Obj         ) { RD_TUPLEi(Ref,&(Obj)); }

#define RD_CONS1f( Ref      )  RD_CONS1fi(Ref) 
#define RD_CONS2f( Ref      )  RD_CONS2fi(Ref) 
#define RD_CONS3f( Ref      )  RD_CONS3fi(Ref) 
#define RD_TUPLEf( Ref      )  RD_TUPLEfi(Ref) 

 

#define MK_DATA(  Sort,   Ref,      Obj,         Size ) { MK_DATAi(Sort,Ref,&(Obj),Size); }
#define MK_MDATA( Sort,   Ref,      Obj,         Size ) { MK_MDATAi(Sort,Ref,&(Obj),Size); }

#define RD_DATA( Ref,      Obj         ) { RD_DATAi(Ref,&(Obj)); }

#define RD_DATAf( Ref      )  RD_DATAfi(Ref) 

#define MK_CONS0x(Sort,Ref) { { { (Ref)->indic = MK_INDIC(  N_CONS0,Sort) ; } ;}; }
#define MK_CONS1x(Sort,Ref,Obj) { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += (1)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), 1); }; };}; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_CONS1,Sort) ; } ; } ; }; }
#define MK_CONS2x(Sort,Ref,Obj) { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += (2)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), 2); }; };}; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_CONS2,Sort) ; } ; } ; }; }
#define MK_CONS3x(Sort,Ref,Obj) { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += (3)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), 3); }; };}; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_CONS3,Sort) ; } ; } ; }; }
#define MK_TUPLEx(Sort,Ref,Obj,Size) { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += (( Size)+1)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), ( Size)+1); }; };}; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_TUPLE,Sort) ; } ; }; { (*((long*)(&((*( Obj)).info)))) = ( Size); ( Obj)->indic=MK_INDIC((0x80+(0)),MK_SORT((long)4));}; }; }
#define MK_DATAx(Sort,Ref,Obj,Size) { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += (( Size)+1)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), ( Size)+1); }; };}; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_DATA,Sort) ; } ; }; { (*((long*)(&((*( Obj)).info)))) = ( Size); ( Obj)->indic=MK_INDIC((0x80+(0)),MK_SORT((long)5));}; }; }
#define MK_MCONS0x(Sort,Ref) { { T_ROBJ Obj ; { { ( Obj ) = allocV.alloc; { if ((allocV.alloc += ((0)+2)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj ), (0)+2); }; };};  Obj  += 2 ; } ; { { (MUT_SELECT_VALUE( Obj ))->indic=MK_INDIC((0x80+(0)),MK_SORT((long)0)); } ; (((T_CELLO*)( Obj ))-1)->indic = MK_INDIC((0x80+(1)),MK_SORT((long)0)); } ; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_MCONS0,Sort) ; } ; } ; }; }
#define MK_MCONS1x(Sort,Ref,Obj) { { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += ((1)+2)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), (1)+2); }; };};  Obj += 2 ; }; { { (MUT_SELECT_VALUE( Obj ))->indic=MK_INDIC((0x80+(0)),MK_SORT((long)0)); } ; (((T_CELLO*)( Obj ))-1)->indic = MK_INDIC((0x80+(1)),MK_SORT((long)0)); }; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_MCONS1,Sort) ; } ; } ; }; }
#define MK_MCONS2x(Sort,Ref,Obj) { { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += ((2)+2)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), (2)+2); }; };};  Obj += 2 ; }; { { (MUT_SELECT_VALUE( Obj ))->indic=MK_INDIC((0x80+(0)),MK_SORT((long)0)); } ; (((T_CELLO*)( Obj ))-1)->indic = MK_INDIC((0x80+(1)),MK_SORT((long)0)); }; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_MCONS2,Sort) ; } ; } ; }; }
#define MK_MCONS3x(Sort,Ref,Obj) { { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += ((3)+2)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), (3)+2); }; };};  Obj += 2 ; }; { { (MUT_SELECT_VALUE( Obj ))->indic=MK_INDIC((0x80+(0)),MK_SORT((long)0)); } ; (((T_CELLO*)( Obj ))-1)->indic = MK_INDIC((0x80+(1)),MK_SORT((long)0)); }; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_MCONS3,Sort) ; } ; } ; }; }
#define MK_MTUPLEx(Sort,Ref,Obj,Size) { { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += ((( Size)+1)+2)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), (( Size)+1)+2); }; };};  Obj += 2 ; }; { { (MUT_SELECT_VALUE( Obj ))->indic=MK_INDIC((0x80+(0)),MK_SORT((long)0)); } ; (((T_CELLO*)( Obj ))-1)->indic = MK_INDIC((0x80+(1)),MK_SORT((long)0)); }; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_MTUPLE,Sort) ; } ; }; { (*((long*)(&((*( Obj)).info)))) = ( Size); ( Obj)->indic=MK_INDIC((0x80+(0)),MK_SORT((long)4));}; }; }
#define MK_MDATAx(Sort,Ref,Obj,Size) { { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += ((( Size)+1)+2)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), (( Size)+1)+2); }; };};  Obj += 2 ; }; { { (MUT_SELECT_VALUE( Obj ))->indic=MK_INDIC((0x80+(0)),MK_SORT((long)0)); } ; (((T_CELLO*)( Obj ))-1)->indic = MK_INDIC((0x80+(1)),MK_SORT((long)0)); }; { ((*Ref).info) = (Obj); { (Ref)->indic = MK_INDIC( N_MDATA,Sort) ; } ; }; { (*((long*)(&((*( Obj)).info)))) = ( Size); ( Obj)->indic=MK_INDIC((0x80+(0)),MK_SORT((long)5));}; }; }
#define RD_CONS1x(Ref,Obj) { { Obj = ((*(Ref)).info) ; }; } 
#define RD_CONS2x(Ref,Obj) { { Obj = ((*(Ref)).info) ; }; } 
#define RD_CONS3x(Ref,Obj) { { Obj = ((*(Ref)).info) ; }; }
#define RD_TUPLEx(Ref,Obj) { { Obj = ((*(Ref)).info) ; }; }
#define RD_DATAx(Ref,Obj) { { Obj = ((*(Ref)).info) ; }; }
#define RD_CONS1fx(Ref)  ((*(Ref)).info) } 
#define RD_CONS2fx(Ref)  ((*(Ref)).info) } 
#define RD_CONS3fx(Ref)  ((*(Ref)).info) }
#define RD_TUPLEfx(Ref)  ((*(Ref)).info) }
#define RD_DATAfx(Ref)  ((*(Ref)).info) }

#define N_NYTERM     (0x80+(3)) 

#define DB_CELL2S_SIZE     28 

  

#define W_ATOM                  0 
#define W_CONS0                 0 
#define W_CONS1                 ((long)1) 
#define W_CONS2                 ((long)2) 
#define W_CONS3                 ((long)3) 
#define W_MCONS0                 (W_CONS0+2) 
#define W_MCONS1                 (W_CONS1+2) 
#define W_MCONS2                 (W_CONS2+2) 
#define W_MCONS3                 (W_CONS3+2) 
#define W_LEVEL                 ((long)level_ncells) 
#define W_WEAK                  ((long)3) 
#define W_STRONG                  ((long)3) 
#define W_NOTERM                  0 

#define W_TUPLE(  Size )       ((Size)+1) 
#define W_MTUPLE( Size )       (W_TUPLE(Size)+2) 
#define W_DATA(   Size )       ((Size)+1) 
#define W_MDATA(  Size )       (W_DATA(Size)+2) 

#define PAGE_MIN_SIZE        \
(   4*sizeof(T_CELL)       \
  + sizeof(T_PAGE)                \
  + 4*sizeof(T_CELL)               )

#define DO_GC( Root     ) {DO_GCi(Root);} 

#define DO_LIGHT_GC( Root     ) {DO_LIGHT_GCi(Root);} 

#define GT_NB_USED_CELLS( Occup     ) { GT_NB_USED_CELLSi(&(Occup)); }
#define GT_NB_USED_PAGES( Occup     ) { GT_NB_USED_PAGESi(&(Occup)); }

#define GV_NEW_PAGE( RefPage, SizePage ) { GV_NEW_PAGEi(RefPage, SizePage); }

#define GT_FREE_PAGE( RefPage,     SizePage  ) { GT_FREE_PAGEi(&RefPage,&SizePage); }

#define INDIC_SELECT_NAT(              indicator )  \
\
((T_NATURE)((indicator)&((0xFF))))  

#define INDIC_SELECT_SORT(         indicator )  \
\
((T_SORT)((indicator)&(~(0xFF)))) 

#define MK_INDIC(                     nature,   sort   )   \
\
((T_INDIC)((nature)+(sort))) 

#define N_ATOM                    (0x08+0x01)
#define N_CONS0                   (0x40+(0x00)+(0x0))
#define N_MCONS0                  (0x40+(0x00)+(0x10))
#define N_CONS1                   (0x40+(0x01)+(0x0))
#define N_MCONS1                  (0x40+(0x01)+(0x10))
#define N_CONS2                   (0x40+(0x02)+(0x0))
#define N_MCONS2                  (0x40+(0x02)+(0x10))
#define N_CONS3                   (0x40+(0x03)+(0x0))
#define N_MCONS3                  (0x40+(0x03)+(0x10))
#define N_TUPLE                   (0x40+(0x04)+(0x0))
#define N_MTUPLE                  (0x40+(0x04)+(0x10))
#define N_DATA                    (0x40+(0x05)+(0x0))
#define N_MDATA                   (0x40+(0x05)+(0x10))
#define N_LEVEL                   0x20
#define N_WEAK                     (0x08+0x02) 
#define N_STRONG                   (0x08+0x04) 
#define N_NOTERM                   (0x08+0x03) 

#define MAX_SORT                    0xFFFFFF 

#define MK_SORT( num           )  ((T_SORT)((num)<<8)) 

#define RD_SORT(        sort   )  \
\
((unsigned long)((sort)>>8)) 

#define CF_MALI( XcepFun,                 RefStream ) { CF_MALIi( XcepFun, RefStream ); }

#define RS_MALI() { RS_MALIi(); }

#define IN_MALI() IN_MALIi()

#define DV_MALI( VarString   ) { DV_MALIi( &(VarString) ); }

#define MUT_SELECT_VALUE( objmut  ) (((T_CELLO*)(objmut))-2)

#define SU_MUT( RefMut,   ObjMut      )  { SU_MUTi(RefMut, &(ObjMut)); }

#define SU_NEW_MUT( RefMut,   ObjMut      )  { SU_NEW_MUTi(RefMut, &(ObjMut)); }

#define AS_MUT( RefMut,  ObjMut       ) { AS_MUTi(RefMut,&(ObjMut)); }

#define AS_MUT_FROM_LEVEL( RefMut,   RefLevel,  ObjMut      ) { AS_MUT_FROM_LEVELi(RefMut, RefLevel, &(ObjMut)); }

#define RD_DIRECT( Ref           ) { RD_DIRECTi(&(Ref)); }

#define RD_DIRECT_IN_LEVEL( Ref,           RefLevel ) { RD_DIRECT_IN_LEVELi(&(Ref),RefLevel); }

#define SU_MUTx(RefMut,ObjMut) { { (ObjMut) = ((*((RefMut))).info); { { { (*(((T_CELLO*)( (ObjMut)))-1)).indic=( rarrV.trail ).indic; ((*(((T_CELLO*)( (ObjMut)))-1)).info)=(( rarrV.trail ).info); }; { ( rarrV.trail ).indic=(*( (RefMut))).indic; (( rarrV.trail ).info)=((*( (RefMut))).info); };} } ;}; }
#define SU_NEW_MUTx(RefMut,ObjMut) { { (ObjMut) = ((*((RefMut))).info); (((T_CELLO*)((ObjMut)))-1)->indic=MK_INDIC((0x80+(0)),MK_SORT((long)1)) ; }; }
#define AS_MUTx(RefMut,ObjMut) { { (ObjMut) = ((*((RefMut))).info); (((T_CELLO*)((ObjMut)))-1)->indic=MK_INDIC((0x80+(0)),MK_SORT((long)1)) ; { allocV.stacklike_space = allocV.alloc; allocV.all_stacklike = (0!=0);}; }; }
#define RD_DIRECTx(Ref) { { { if (( INDIC_SELECT_NAT((*((Ref))).indic) )&(0x10 | 0x20)) { RD_DIRECT_LOOP(&((Ref))); }; } ; }; }

#define TOP_LEVEL (rarrV.top_level)

#define LEVEL_SELECT_NEXT_LEVEL( objlevel ) (((T_CELLO*)(objlevel))+2)

#define LEVEL_SELECT_ROOT( objlevel ) (((T_CELLO*)(objlevel))+3)

#define MK_TOP_LEVEL( Sort,   Root     )  \
\
{ MK_TOP_LEVELi(Sort,Root); }

#define RD_LEVEL( RefLevel,  ObjLevel    ) { RD_LEVELi(RefLevel,&(ObjLevel)); }

#define RD_LEVELf( RefLevel )  RD_LEVELfi(RefLevel) 

#define DO_PUSH_TOP_LEVEL() { DO_PUSH_TOP_LEVELi(); }

#define DO_POP_TOP_LEVEL( Obj         ) { DO_POP_TOP_LEVELi(&(Obj)); }

#define GT_HEIGHT( RefLevel, Height    ) { GT_HEIGHTi(RefLevel,&(Height)); }

#define AS_LEVEL_TOP( RefLevel ) { AS_LEVEL_TOPi(RefLevel); }

#define AS_LEVEL( LowLevel, HighLevel ) { AS_LEVELi(LowLevel,HighLevel); }

#define RD_LEVELx(RefLevel,ObjLevel) { ObjLevel = ((*(RefLevel)).info); }
#define RD_LEVELfx(RefLevel)  ((*(RefLevel)).info)
#define DO_PUSH_TOP_LEVELx() { { { (((T_CELLO*)( ((rarrV.ghost_level).info) )))->indic = MK_INDIC((0x80+(0)),MK_SORT((long)8)); }; { (rarrV.top_level).indic=(rarrV.ghost_level).indic; ((rarrV.top_level).info)=((rarrV.ghost_level).info); }; { ( rarrV.trail).indic=( rarrV.top_level ).indic; (( rarrV.trail).info)=(( rarrV.top_level ).info); }; }; }

#define WEAK_SELECT_VALUE(   objweak   ) ((T_CELLO*)((objweak)+2))
#define STRONG_SELECT_VALUE( objstrong ) ((T_CELLO*)((objstrong)+2))

 

#define MK_WEAK(   Sort,   Ref,      Obj         ) { MK_WEAKi(Sort,Ref,&(Obj)); }
#define MK_STRONG( Sort,   Ref,      Obj         ) { MK_STRONGi(Sort,Ref,&(Obj)); }

#define RD_WEAK(   Ref,      Obj         ) { RD_WEAKi(Ref,&(Obj)); }
#define RD_STRONG( Ref,      Obj         ) { RD_STRONGi(Ref,&(Obj)); }

#define RD_WEAKf(   Ref      )  RD_WEAKfi(Ref) 
#define RD_STRONGf( Ref      )  RD_STRONGfi(Ref) 

#define GT_UNUSED_STRONG( Ref      ) { GT_UNUSED_STRONGi(Ref); }

#define MK_WEAKx(Sort,Ref,Obj) { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += (3)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), 3); }; };}; { ((*Ref).info) = (Obj); (Ref)->indic = MK_INDIC(N_WEAK,Sort) ; } ; { (( Obj ))->indic = MK_INDIC((0x80+(0)),MK_SORT((long)6));}; }; }
#define MK_STRONGx(Sort,Ref,Obj) { { { ( Obj) = allocV.alloc; { if ((allocV.alloc += (3)) > allocV.end_of_space ) { DO_OVERFLOW(&( Obj), 3); }; };}; { ((*Ref).info) = (Obj); (Ref)->indic = MK_INDIC(N_STRONG,Sort) ; } ; { ((Obj))->indic = MK_INDIC((0x80+(0)),MK_SORT((long)7)); { ( *((Obj)+1)).indic=( useV.used_strong_terms ).indic; (( *((Obj)+1)).info)=(( useV.used_strong_terms ).info); }; { ( useV.used_strong_terms).indic=( *Ref ).indic; (( useV.used_strong_terms).info)=(( *Ref ).info); };}; { allocV.stacklike_space = allocV.alloc; allocV.all_stacklike = (0!=0);}; }; }
#define RD_WEAKx(Ref,Obj) { { Obj = ((*(Ref)).info) ; }; } 
#define RD_STRONGx(Ref,Obj) { { Obj = ((*(Ref)).info) ; }; } 
#define RD_WEAKfx(Ref)  ((*(Ref)).info) } 
#define RD_STRONGfx(Ref)  ((*(Ref)).info) } 

#define X_ERROR                   0 
#define X_MK_OVERFLOW             5 
#define X_GC_OVERFLOW             6 
#define X_DBUG                    1 
#define X_WARNING                 2 
#define X_TRACE                   3 

#define ST_CELL(              To,       From     ) {ST_CELLi(To,From);}

#define ST_ATOM(                             To,       Sort,   Info   ) {ST_ATOMi(To,Sort,Info);}

#define EQ_CELL(             cell1,    cell2    )  EQ_CELLi(cell1,cell2) 

#define ST_CELLx(To,From) { { (*(To)).indic=(*(From)).indic; ((*(To)).info)=((*(From)).info); }; }
#define ST_ATOMx(To,Sort,Info) { { (*(To)).indic=MK_INDIC(N_ATOM,(Sort)); (*(To)).info=(Info); }; }
#define EQ_CELLx(Cell1,Cell2)  ( (((*(Cell1)).info)==((*(Cell2)).info)) && ((*(Cell1)).indic==(*(Cell2)).indic) ) 

/*[*//***************************************************************************
% MALIv06                        file :  source/commande/cmpsE.h 
%
%     AUTHOR
%          INRIA, Domaine de Voluceau-Rocquencourt, BP 105, 78153 LE CHESNAY Cedex, FRANCE
%          Tlx: 697 033 F, Fax: (33) (1) 39 63 53 30, Phone: (33) (1) 39 63 55 11
%
%          This software has been designed and programmed by Olivier Ridoux 
%          at IRISA.  For further information or comments, e-mail to
%          maliv06@irisa.fr
%          or write to
%          IRISA, Campus Universitaire de Beaulieu, 35042 RENNES Cedex, FRANCE
%          Tlx: Unirisa 950 473 F, Fax: (33) 99 38 38 32, Phone: (33) 99 84 71 00
%
%     COPYRIGHT
%          Both this software, named MALIv06, and its documentation are
%
%              Copyrighted 1992 by INRIA, all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : LICENSING).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and neither IRISA nor INRIA are affiliated with that organization.
%**************************************************************************//*]*/
/*[*/
extern
T_ROBJ RD_CONS1fi();
extern
T_ROBJ RD_CONS2fi();
extern
T_ROBJ RD_CONS3fi();
extern
T_ROBJ RD_TUPLEfi();
extern
T_ROBJ RD_DATAfi();
/*]*/
/*[*//***************************************************************************
% MALIv06                        file :  source/commande/dbugE.h 
%
%     AUTHOR
%          INRIA, Domaine de Voluceau-Rocquencourt, BP 105, 78153 LE CHESNAY Cedex, FRANCE
%          Tlx: 697 033 F, Fax: (33) (1) 39 63 53 30, Phone: (33) (1) 39 63 55 11
%
%          This software has been designed and programmed by Olivier Ridoux 
%          at IRISA.  For further information or comments, e-mail to
%          maliv06@irisa.fr
%          or write to
%          IRISA, Campus Universitaire de Beaulieu, 35042 RENNES Cedex, FRANCE
%          Tlx: Unirisa 950 473 F, Fax: (33) 99 38 38 32, Phone: (33) 99 84 71 00
%
%     COPYRIGHT
%          Both this software, named MALIv06, and its documentation are
%
%              Copyrighted 1992 by INRIA, all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : LICENSING).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and neither IRISA nor INRIA are affiliated with that organization.
%**************************************************************************//*]*/
/*[*/
extern
char * DB_CELL2S();
extern 
int /* bool */ DB_TRACE();
/*]*/
/*[*//***************************************************************************
% MALIv06                        file :  source/commande/rarrE.h 
%
%     AUTHOR
%          INRIA, Domaine de Voluceau-Rocquencourt, BP 105, 78153 LE CHESNAY Cedex, FRANCE
%          Tlx: 697 033 F, Fax: (33) (1) 39 63 53 30, Phone: (33) (1) 39 63 55 11
%
%          This software has been designed and programmed by Olivier Ridoux 
%          at IRISA.  For further information or comments, e-mail to
%          maliv06@irisa.fr
%          or write to
%          IRISA, Campus Universitaire de Beaulieu, 35042 RENNES Cedex, FRANCE
%          Tlx: Unirisa 950 473 F, Fax: (33) 99 38 38 32, Phone: (33) 99 84 71 00
%
%     COPYRIGHT
%          Both this software, named MALIv06, and its documentation are
%
%              Copyrighted 1992 by INRIA, all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : LICENSING).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and neither IRISA nor INRIA are affiliated with that organization.
%**************************************************************************//*]*/
/*[*/
extern
T_ROBJ RD_LEVELfi();
/*]*/
/*[*//***************************************************************************
% MALIv06                        file :  source/commande/useE.h 
%
%     AUTHOR
%          INRIA, Domaine de Voluceau-Rocquencourt, BP 105, 78153 LE CHESNAY Cedex, FRANCE
%          Tlx: 697 033 F, Fax: (33) (1) 39 63 53 30, Phone: (33) (1) 39 63 55 11
%
%          This software has been designed and programmed by Olivier Ridoux 
%          at IRISA.  For further information or comments, e-mail to
%          maliv06@irisa.fr
%          or write to
%          IRISA, Campus Universitaire de Beaulieu, 35042 RENNES Cedex, FRANCE
%          Tlx: Unirisa 950 473 F, Fax: (33) 99 38 38 32, Phone: (33) 99 84 71 00
%
%     COPYRIGHT
%          Both this software, named MALIv06, and its documentation are
%
%              Copyrighted 1992 by INRIA, all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : LICENSING).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and neither IRISA nor INRIA are affiliated with that organization.
%**************************************************************************//*]*/
/*[*/
extern
T_ROBJ RD_WEAKfi();
extern
T_ROBJ RD_STRONGfi();
/*]*/
/****************************************************************************
% PM        file : term.h (7/21/93)
%
%     AUTHOR
%          IRISA/INRIA/Universite de Rennes I/INSA de Rennes/CNRS
%            35042 Rennes Cedex - France
%          Phone : (33) 99 84 71 00       Fax : (33) 99 38 38 32
%
%     This software has been designed and programmed by P Brisset & O Ridoux
%     at IRISA. For further information or comments email :  pm@irisa.fr or
%     write to IRISA (Institut de Recherche en Informatique et Syste`mes
%     Ale'atoires)
%
%     COPYRIGHT
%          Both this software PM and its documentation are
%
%              Copyrighted 1992 by IRISA
%                         all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : Licensing).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and IRISA is NOT affiliated with that organization.
******************************************************************************/
/* LES SORTES */

#define MIN_SORT 100

/*** sortes code'es "dense'ment" pour tests de compatibilite' ***/
#define SORT_C_APPL           MK_SORT(0)
#define SORT_APPL             MK_SORT(1)
#define SORT_C_ABSTR          MK_SORT(4)
#define SORT_ABSTR            MK_SORT(5)
#define SORT_C_ETA_ABSTR      MK_SORT(6)
#define SORT_ETA_ABSTR        MK_SORT(7)
#define SORT_C_CONS           MK_SORT(8)
#define SORT_CONS             MK_SORT(9)

#define SORT_C_APPL1          MK_SORT(12)
#define SORT_APPL1            MK_SORT(13)

#define SORT_LDISPLA          MK_SORT(17)
#define SORT_VAR              MK_SORT(18)
#define SORT_REF              MK_SORT(19)
#define SORT_UVAR             MK_SORT(20)
#define SORT_VARA             MK_SORT(21)
#define SORT_T_ARROW          MK_SORT(22)
#define SORT_T_UNK            MK_SORT(23)
#define SORT_T_APPL1          MK_SORT(24)
#define SORT_T_SYMB           MK_SORT(25)
#define SORT_T_NUPLE          MK_SORT(26)
#define SORT_CONS_DISPLA      MK_SORT(27)
#define SORT_DYN_FACTS        MK_SORT(28)

#define SORT_SUBST_TMP1       MK_SORT(32)
#define SORT_SUBST_TMP2       MK_SORT(33)
#define SORT_LBD_CTX          MK_SORT(34)
#define SORT_UN_PB            MK_SORT(35)
#define SORT_UVAR_REPL        MK_SORT(36)
#define SORT_VAR_UVAR         MK_SORT(37)
#define SORT_TRUE             MK_SORT(38)
#define SORT_FF_PAIR          MK_SORT(39)
#define SORT_FF_EMPTY         MK_SORT(40)
#define SORT_FULL_GOAL        MK_SORT(41)
#define SORT_NODE             MK_SORT(42)
#define SORT_HAT_FG           MK_SORT(43)
#define SORT_NYTERM           MK_SORT(50)
#define SORT_INTEGER          MK_SORT(51)
#define SORT_FLOAT            MK_SORT(52)
#define SORT_STRING           MK_SORT(53)

#define SORT_SYMB             MK_SORT(55)

#define SORT_NIL              MK_SORT(59)
#define SORT_CHPT             MK_SORT(60)

#define SORT_ROOT_CHPT        MK_SORT(62)
#define SORT_GOAL             MK_SORT(63)
#define SORT_ROOT_GC_DIRECT   MK_SORT(64)
#define SORT_EGS              MK_SORT(65)
#define SORT_ROOT_GC          MK_SORT(66)
#define SORT_FR_LIST          SORT_CONS
#define SORT_FF_LIST          SORT_CONS

#define N_UNK                 N_MCONS1
#define N_SUBST               N_MCONS1
#define SORT_UNK(PILEV)       MK_SORT(MIN_SORT + 2 * PILEV)
#define UNK_GET_PILEV(where) (long)((RD_SORT(INDIC_SELECT_SORT(where->indic)) - MIN_SORT) / 2)
#define SORT_SUBST(PILEV)     MK_SORT(MIN_SORT + 2 * PILEV + 1)
#define SUBST_GET_PILEV(where) (long)((RD_SORT(INDIC_SELECT_SORT(where->indic)) - MIN_SORT - 1) / 2)

#define N_UNK_CTR                N_MCONS3
#define SORT_UNK_CTR(PILEV)      SORT_UNK(PILEV)
/*** #define UNK_CTR_GET_PILEV(where) UNK_GET_PILEV(where) ***/

#define SORT_NUPLE(I)         MK_SORT(MIN_SORT + 2 * I)
#define SORT_C_NUPLE(I)       MK_SORT(MIN_SORT + 2 * I + 1)

#define SORT_DISPLA           SORT_NUPLE(1L)



/* LES INDICATEURS */
/*** sortes des MCONS1 utilise'es a` partir de SORT_UNK(0) par IND_UNK ***/
/*** sortes des MCONS1 utilise'es a` partir de SORT_SUBST(0) par IND_SUBST ***/
/*** sortes des TUPLE utilise'es a` partir de SORT_NUPLE(0) par IND_NUPLE ***/


#define IND_NYTERM    MK_INDIC(N_NYTERM, SORT_NYTERM) 

#define IND_INTEGER           MK_INDIC(N_ATOM,      SORT_INTEGER)
#define IND_FLOAT             MK_INDIC(N_ATOM,      SORT_FLOAT)
#define IND_STRING            MK_INDIC(N_ATOM,      SORT_STRING)
#define IND_SYMB              MK_INDIC(N_ATOM,      SORT_SYMB)

#define IND_T_SYMB            MK_INDIC(N_ATOM,      SORT_T_SYMB)
#define IND_TRUE              MK_INDIC(N_ATOM,      SORT_TRUE)

#define IND_NIL               MK_INDIC(N_CONS0,     SORT_NIL)
#define IND_EGS               MK_INDIC(N_CONS0,     SORT_EGS)
#define IND_NODE              MK_INDIC(N_CONS0,     SORT_NODE)
#define IND_T_UNK             MK_INDIC(N_MCONS0,    SORT_T_UNK)
#define IND_FF_EMPTY          MK_INDIC(N_MCONS0,    SORT_FF_EMPTY)

#define IND_VAR               MK_INDIC(N_CONS1,     SORT_VAR)
#define IND_UNK(PILEV)        MK_INDIC(N_UNK,       SORT_UNK(PILEV))

#define IND_LDISPLA           MK_INDIC(N_MCONS1,    SORT_LDISPLA)
#define IND_HAT_FG            MK_INDIC(N_MCONS1,    SORT_HAT_FG)
#define IND_VARA              MK_INDIC(N_MCONS1,    SORT_VARA)
/*** substitutable terms ***/
#define IND_SUBST(PILEV)      MK_INDIC(N_SUBST,     SORT_SUBST(PILEV))

#define IND_T_ARROW           MK_INDIC(N_CONS2,     SORT_T_ARROW)
#define IND_CONS_DISPLA       MK_INDIC(N_CONS2, SORT_CONS_DISPLA)
#define IND_UVAR              MK_INDIC(N_CONS2,     SORT_UVAR)


#define IND_CONS              MK_INDIC(N_CONS2,     SORT_CONS)
#define IND_FR_LIST           MK_INDIC(N_CONS2,     SORT_FR_LIST)
#define IND_FF_LIST           MK_INDIC(N_CONS2,     SORT_FF_LIST)
#define IND_C_CONS            MK_INDIC(N_CONS2,     SORT_C_CONS)

#define IND_LBD_CTX           MK_INDIC(N_CONS2,     SORT_LBD_CTX)
#define IND_VAR_UVAR          MK_INDIC(N_CONS2,     SORT_VAR_UVAR)

#define IND_UVAR_REPL         MK_INDIC(N_MCONS2,    SORT_UVAR_REPL)

#define IND_UNK_CTR(PILEV)     MK_INDIC(N_MCONS3,    SORT_UNK_CTR(PILEV))

#define IND_APPL1             MK_INDIC(N_TUPLE,     SORT_APPL1)
#define IND_C_APPL1           MK_INDIC(N_TUPLE,     SORT_C_APPL1)
#define IND_ROOT_CHPT         MK_INDIC(N_TUPLE,     SORT_ROOT_CHPT)
#define IND_ROOT_GC           MK_INDIC(N_TUPLE,     SORT_ROOT_GC)
#define IND_ROOT_GC_DIRECT    MK_INDIC(N_TUPLE,     SORT_ROOT_GC_DIRECT)
#define IND_GOAL              MK_INDIC(N_TUPLE,     SORT_GOAL)
#define IND_FULL_GOAL         MK_INDIC(N_TUPLE,     SORT_FULL_GOAL)
#define IND_UN_PB             MK_INDIC(N_TUPLE,     SORT_UN_PB)
#define IND_NUPLE(I)          MK_INDIC(N_TUPLE,     SORT_NUPLE(I))
#define IND_C_NUPLE(I)        MK_INDIC(N_TUPLE,     SORT_C_NUPLE(I))
#define IND_ABSTR             MK_INDIC(N_MTUPLE,    SORT_ABSTR)
#define IND_C_ABSTR           MK_INDIC(N_MTUPLE,    SORT_C_ABSTR)
#define IND_ETA_ABSTR         MK_INDIC(N_MTUPLE,    SORT_ETA_ABSTR)
#define IND_C_ETA_ABSTR       MK_INDIC(N_MTUPLE,    SORT_C_ETA_ABSTR)
#define IND_T_APPL1           MK_INDIC(N_TUPLE,     SORT_T_APPL1)
#define IND_T_NUPLE           MK_INDIC(N_TUPLE,     SORT_T_NUPLE)
#define IND_APPL              MK_INDIC(N_MTUPLE,    SORT_APPL)
#define IND_C_APPL            MK_INDIC(N_MTUPLE,    SORT_C_APPL)
#define IND_FF_PAIR           MK_INDIC(N_MTUPLE,    SORT_FF_PAIR)
#define IND_DISPLA            MK_INDIC(N_TUPLE,     SORT_DISPLA)
#define IND_DYN_FACTS         MK_INDIC(N_TUPLE,     SORT_DYN_FACTS)

#define IND_CHPT              MK_INDIC(N_LEVEL,     SORT_CHPT)

#define IND_REF               MK_INDIC(N_ATOM,   SORT_REF)

#define ANADIC                2L

/* OPERATIONS DE SELECTION */

/****** T_CELLO *          (T_ROBJ, unsigned long) */
#define NUPLE_SELECT_ITH(ref_obj, ith) TUPLE_SELECT_ITH(ref_obj, ith)


/****** T_CELLO *          (T_ROBJ) */
#define UN_PB_SELECT_1ST_TERM(ref_obj) TUPLE_SELECT_ITH(ref_obj, 1)

/****** T_CELLO *          (T_ROBJ) */
#define UN_PB_SELECT_2ND_TERM(ref_obj) TUPLE_SELECT_ITH(ref_obj, 2)

/****** T_CELLO *          (T_ROBJ) */
#define UN_PB_SELECT_1ST_CTX(ref_obj) TUPLE_SELECT_ITH(ref_obj, 3)

/****** T_CELLO *          (T_ROBJ) */
#define UN_PB_SELECT_2ND_CTX(ref_obj) TUPLE_SELECT_ITH(ref_obj, 4)

/****** T_CELLO *          (T_ROBJ) */
#define UN_PB_SELECT_PILEV(ref_obj) TUPLE_SELECT_ITH(ref_obj, 5)


/****** T_CELLO *          (T_ROBJ) */
#define DYN_FACTS_SELECT_VARA(ref_obj, i) TUPLE_SELECT_ITH(ref_obj, i)


/****** T_CELLO *          (T_ROBJ) */
#define FF_PAIR_SELECT_1ST_TERM(ref_obj) TUPLE_SELECT_ITH(ref_obj, 1)

/****** T_CELLO *          (T_ROBJ) */
#define FF_PAIR_SELECT_2ND_TERM(ref_obj) TUPLE_SELECT_ITH(ref_obj, 2)

/****** T_CELLO *          (T_ROBJ) */
#define FF_PAIR_SELECT_1ST_CTX(ref_obj) TUPLE_SELECT_ITH(ref_obj, 3)

/****** T_CELLO *          (T_ROBJ) */
#define FF_PAIR_SELECT_2ND_CTX(ref_obj) TUPLE_SELECT_ITH(ref_obj, 4)

/****** T_CELLO *          (T_ROBJ) */
#define FF_PAIR_SELECT_PILEV(ref_obj) TUPLE_SELECT_ITH(ref_obj, 5)



/****** T_CELLO *          (T_ROBJ) */
#define APPL1_SELECT_FUNCTOR(ref_obj) TUPLE_SELECT_ITH(ref_obj, 1L)

/****** T_CELLO *      (T_ROBJ, numT) */
#define APPL1_SELECT_ARG(ref_obj, num_arg) TUPLE_SELECT_ITH(ref_obj,(num_arg)+1L)

/****** T_CELLO *       (cellobjT *, numT) */
#define APPL1_SHIFT(ptr_cell,   num_arg) TUPLE_SHIFT(ptr_cell, num_arg)



/****** T_CELLO *          (T_ROBJ) */
#define ABSTR_SELECT_TERM(ref_obj) TUPLE_SELECT_ITH(ref_obj, 1L)

/****** T_CELLO *      (T_ROBJ, numT) */
#define ABSTR_SELECT_VAR(ref_obj, num_var) TUPLE_SELECT_ITH(ref_obj,(num_var)+1L)

#define ABSTR_GET_ARITY(robj) (TUPLE_GET_SIZE(robj) - 1L)


/****** T_CELLO *      (T_ROBJ, numT) */
#define APPL_SELECT_TERM(ref_obj, num_term) TUPLE_SELECT_ITH(ref_obj,num_term)
#define APPL_SELECT_HEAD(ref_obj) APPL_SELECT_TERM(ref_obj, 1)
#define APPL_GET_LENGTH(robj) TUPLE_GET_SIZE(robj)

/****** T_CELLO *       (cellobjT *, numT) */
#define APPL_SHIFT(ptr_cell,   num_arg) TUPLE_SHIFT(ptr_cell, num_arg)

/****** T_CELLO *          (T_ROBJ) */
#define VAR_SELECT_NODE(ref_obj) CONS_SELECT_1ST(ref_obj)


/****** T_CELLO *          (T_ROBJ) */
#define HAT_FG_SELECT_FG(ref_obj) CONS_SELECT_1ST(ref_obj)

/****** T_CELLO *          (T_ROBJ) */
#define VARA_SELECT_LIST(ref_obj) CONS_SELECT_1ST(ref_obj)


/****** T_CELLO *          (T_ROBJ) */
#define VAR_UVAR_SELECT_VAR(ref_obj) CONS_SELECT_1ST(ref_obj)

/****** T_CELLO *          (T_ROBJ) */
#define VAR_UVAR_SELECT_UVAR(ref_obj) CONS_SELECT_2ND(ref_obj)


/****** T_CELLO *          (T_ROBJ) */
#define UVAR_REPL_SELECT_VAR_UVAR(ref_obj) CONS_SELECT_1ST(ref_obj)

/****** T_CELLO *          (T_ROBJ) */
#define UVAR_REPL_SELECT_TERM(ref_obj) CONS_SELECT_2ND(ref_obj)


/****** T_CELLO *          (T_ROBJ) */
#define UNK_SELECT_TYPE(ref_obj) CONS_SELECT_1ST(ref_obj)


/****** T_CELLO *          (T_ROBJ)
#define UNK_CTR_SELECT_TYPE(ref_obj) CONS_SELECT_1ST(ref_obj)
il faut utiliser UNK_SELECT_TYPE ***/

/****** T_CELLO *          (T_ROBJ) */
#define UNK_CTR_SELECT_FF(ref_obj) CONS_SELECT_2ND(ref_obj)

/****** T_CELLO *          (T_ROBJ) */
#define UNK_CTR_SELECT_FG(ref_obj) CONS_SELECT_3RD(ref_obj)



/****** T_CELLO *     (T_ROBJ) */
#define CONS_SELECT_CAR(ref_obj) CONS_SELECT_1ST(ref_obj)

/****** T_CELLO *     (T_ROBJ) */
#define CONS_SELECT_CDR(ref_obj) CONS_SELECT_2ND(ref_obj)


/****** T_CELLO *     (T_ROBJ) */
#define UVAR_SELECT_PILEV(ref_obj) CONS_SELECT_1ST(ref_obj)

/****** T_CELLO *     (T_ROBJ) */
#define UVAR_SELECT_TYPE(ref_obj) CONS_SELECT_2ND(ref_obj)


/****** T_CELLO *     (T_ROBJ) */
#define FR_LIST_SELECT_UN_PB(ref_obj) CONS_SELECT_1ST(ref_obj)

/****** T_CELLO *     (T_ROBJ) */
#define FR_LIST_SELECT_FR_LIST(ref_obj) CONS_SELECT_2ND(ref_obj)


/****** T_CELLO *     (T_ROBJ) */
#define FF_LIST_SELECT_FF_PAIR(ref_obj) CONS_SELECT_1ST(ref_obj)

/****** T_CELLO *     (T_ROBJ) */
#define FF_LIST_SELECT_FF_LIST(ref_obj) CONS_SELECT_2ND(ref_obj)


#define LBD_CTX_SELECT_VAR(ref_obj) CONS_SELECT_1ST(ref_obj)

#define LBD_CTX_SELECT_LBD_CTX(ref_obj) CONS_SELECT_2ND(ref_obj)




/****** T_CELLO *     (T_ROBJ) */
#define T_ARROW_SELECT_1ST(ref_obj) CONS_SELECT_1ST(ref_obj)

/****** T_CELLO *     (T_ROBJ) */
#define T_ARROW_SELECT_2ND(ref_obj) CONS_SELECT_2ND(ref_obj)



/****** T_CELLO *          (T_ROBJ) */
#define T_APPL1_SELECT_FUNCTOR(ref_obj) TUPLE_SELECT_ITH(ref_obj, 1L)

/****** T_CELLO *      (T_ROBJ, numT) */
#define T_APPL1_SELECT_ARG(ref_obj, num_arg) TUPLE_SELECT_ITH(ref_obj,(num_arg)+1L)


/****** T_CELLO *      (T_ROBJ, numT) */
#define T_NUPLE_SELECT_ITH(ref_obj, num_arg) TUPLE_SELECT_ITH(ref_obj, num_arg)


/****** T_CELLO *     (T_ROBJ) */
#define SUBST_SELECT_TERM(ref_obj) CONS_SELECT_1ST(ref_obj)

/****** T_CELLO *     (T_ROBJ) */
#define SUBST_SELECT_SUBST(ref_obj) MUT_SELECT_VALUE(ref_obj)

/****** T_CELLO *      (T_ROBJ) */
#define CHPT_SELECT_ROOT(ref_obj) LEVEL_SELECT_ROOT(ref_obj)



/****** T_CELLO *         (T_ROBJ) */
#define ROOT_CHPT_SELECT_GS(ref_obj) TUPLE_SELECT_ITH(ref_obj,1L)

/****** T_CELLO *           (T_ROBJ) */
#define ROOT_CHPT_SELECT_PRED(ref_obj) TUPLE_SELECT_ITH(ref_obj,2L)

/****** T_CELLO *            (T_ROBJ) */
#define ROOT_CHPT_SELECT_ENTRY(ref_obj) TUPLE_SELECT_ITH(ref_obj,3L)

/****** T_CELLO *            (T_ROBJ) */
#define ROOT_CHPT_SELECT_PILEV(ref_obj) TUPLE_SELECT_ITH(ref_obj,4L)

/****** T_CELLO *          (T_ROBJ, numT) */
#define ROOT_CHPT_SELECT_DYN_FACTS(ref_obj) TUPLE_SELECT_ITH(ref_obj,4L+1)

/****** T_CELLO *          (T_ROBJ, numT) */
#define ROOT_CHPT_SELECT_ARG(ref_obj, num_arg) TUPLE_SELECT_ITH(ref_obj,(num_arg+4L+1L))

/****** T_CELLO *           (cellobjT *, numT) */
#define ROOT_CHPT_SHIFT(ptr_cell,   num_arg) TUPLE_SHIFT(ptr_cell, num_arg)




/****** T_CELLO *       (T_ROBJ) */
#define ROOT_GC_SELECT_GS(ref_obj) TUPLE_SELECT_ITH(ref_obj,1L)

/****** T_CELLO *          (T_ROBJ, numT) */
#define ROOT_GC_SELECT_DYN_FACTS(ref_obj) TUPLE_SELECT_ITH(ref_obj,2L)

/****** T_CELLO *       (T_ROBJ) */
#define ROOT_GC_DIRECT_SELECT_GS(ref_obj) TUPLE_SELECT_ITH(ref_obj,1L)

/****** T_CELLO *          (T_ROBJ, numT) */
#define ROOT_GC_DIRECT_SELECT_DYN_FACTS(ref_obj) TUPLE_SELECT_ITH(ref_obj,2L)

/****** T_CELLO *        (T_ROBJ, numT) */
#define ROOT_GC_SELECT_ARG(ref_obj, num_arg) TUPLE_SELECT_ITH(ref_obj,(num_arg+2L))

/****** T_CELLO *      (T_ROBJ) */
#define GOAL_SELECT_GOAL(ref_obj) TUPLE_SELECT_ITH(ref_obj, 1L)

/****** T_CELLO *      (T_ROBJ) */
#define GOAL_SELECT_PRED(ref_obj) TUPLE_SELECT_ITH(ref_obj, 2L)

/****** T_CELLO *     (T_ROBJ, numT) */
#define GOAL_SELECT_ARG(ref_obj, num_arg) TUPLE_SELECT_ITH(ref_obj, (num_arg)+2)

/****** T_CELLO *      (T_ROBJ) */
#define FULL_GOAL_SELECT_GOAL(ref_obj) TUPLE_SELECT_ITH(ref_obj, 1L)

/****** T_CELLO *      (T_ROBJ) */
#define FULL_GOAL_SELECT_PILEV(ref_obj) TUPLE_SELECT_ITH(ref_obj, 2L)

/****** T_CELLO *      (T_ROBJ) */
#define FULL_GOAL_SELECT_DYN_FACT(ref_obj, i) TUPLE_SELECT_ITH(ref_obj, 2L + i)



/****** T_CELLO *      (T_ROBJ) */
#define LDISPLA_SELECT_LIST(ref_obj) CONS_SELECT_1ST(ref_obj)


#define DISPLA_SELECT_VARNAME(robj) NUPLE_SELECT_ITH(robj, 1)
#define DISPLA_SELECT_TERM(robj) NUPLE_SELECT_ITH(robj, 2)
#define DISPLA_SELECT_ENTRY(robj) NUPLE_SELECT_ITH(robj, 3)
#define DISPLA_SELECT_FILENAME(robj) NUPLE_SELECT_ITH(robj, 4)
#define DISPLA_SELECT_LINENO(robj) NUPLE_SELECT_ITH(robj, 5)


/****** Exec   (Exec,    numT) */
#define MKA_w_a(mk_what, num_arg) \
mk_what(GOAL_SELECT_ARG(gg,num_arg))

/****** Exec     (Exec,    numT,    Gen valueT) */
#define MKA_w_a_v(mk_what, num_arg, value) \
mk_what(value, GOAL_SELECT_ARG(gg,num_arg))

/****** Exec     (Exec,    numT,    numT) */
#define MKA_w_a_u(mk_what, num_arg, num_unk) \
mk_what(GOAL_SELECT_ARG(gg,num_arg), num_unk)

/****** Exec     (Exec,    numT,    numT) */
#define MKA_w_a_u_o(mk_what, num_arg, num_unk, var_robj) \
mk_what(GOAL_SELECT_ARG(gg,num_arg), num_unk, var-robj)

/****** Exec       (Exec,    numT,    symbT *, T_ROBJ *) */
#define MKA_w_a_f_o(mk_what, num_arg, functor,  var_robj) \
mk_what(functor, GOAL_SELECT_ARG(gg,num_arg), var_robj)

/****** Exec       (Exec,    long, numT,    symbT *, T_ROBJ *) */
#define MKA_w_s_a_o_l(mk_what, sort, num_arg, var_robj, length) \
mk_what(sort, GOAL_SELECT_ARG(gg,num_arg), var_robj, length)

/****** Exec     (Exec,    numT,    T_ROBJ *) */
#define MKA_w_a_o(mk_what, num_arg, var_robj) \
mk_what(GOAL_SELECT_ARG(gg,num_arg), var_robj)


#define MKF_INTEGER(value, num_arg) \
MK_INTEGER(value, &rr[num_arg])

#define MKF_FLOAT(value, num_arg) \
MK_FLOAT(value, &rr[num_arg])

#define MKF_STRING(value, num_arg) \
MK_STRING(value, &rr[num_arg])

#define MKF_SYMB(value, num_arg) \
MK_SYMB(value, &rr[num_arg])

#define MKF_NAME(num_arg, value) \
MK_NAME(&rr[num_arg], value)

#define MKF_NIL(num_arg) \
MK_NIL(&rr[num_arg])

#define MKF_CUT(num_arg) \
MK_CUT(&rr[num_arg])

#define MKF_NUPLE(sort, num_arg, var_robj, length) \
MK_NUPLE(sort, &rr[num_arg], var_robj, length)

#define MKF_APPL1(functor, num_arg, var_robj) \
MK_APPL1(functor, &rr[num_arg], var_robj)

#define MKF_CONS(num_arg, var_robj) \
MK_CONS(&rr[num_arg], var_robj)

#define MKF_SUBST(num_arg, var_robj) \
MK_SUBST(&rr[num_arg], var_robj)

#define MKF_UNK1(num_arg, num) \
MK_UNK1(&rr[num_arg], num)

#define MKF_REF1(num_arg, num) \
MK_REF1(&rr[num_arg], num)

#define MKF_UNKN(num_arg, num) \
MK_UNKN(&rr[num_arg], num)

#define MKF_REFN(num_arg, num) \
MK_REFN(&rr[num_arg], num)

#define MKF_APPL(length, num_arg, var_robj) \
MK_APPL(length, &rr[num_arg], var_robj)

#define MKF_ABSTR(length, num_arg, var_robj) \
MK_C_ABSTR(length, &rr[num_arg], var_robj)

#define MKF_ETA_ABSTR(length, num_arg, var_robj) \
MK_C_ETA_ABSTR(length, &rr[num_arg], var_robj)

#define MK_FIRST_GOAL() \
{control.body.where = &control.body.gs;}

#define MKF()
#define MKA()

#ifndef DBUG
#define DEBUG(X) ;
#define IS_TRUE(X, Y) ;
#else
#define DEBUG(X) X
#define IS_TRUE(X, Mess) {if (!(X)) my_abort(Mess);}
#endif

#ifdef DBUG
#define ASSIGN_P2_TO_P1(a, b) ST_CELL(&(a),&(b))
#define ST_CELL_WNW(a, b) {pm.xcep.warning_on = falseC; ST_CELL(a, b); pm.xcep.warning_on = trueC; }
#else
#define ASSIGN_P2_TO_P1(a, b) ST_CELLx(&(a),&(b))
#define ST_CELL_WNW(a, b) ST_CELLx(a, b)
#endif

#ifdef DBUG
#define TEST_P1_EQ_P2(a, b) EQ_CELL(a, b)
#else
#define TEST_P1_EQ_P2(a, b) EQ_CELLx(a, b)
#endif

#define RD_DIREC RD_DIRECTx

#define DIRECT_NAME(X) DEBUG({ T_CELL *cell = X; RD_DIREC(cell); \
			      if (cell != X) \
                                my_abort("STRONG ERROR (DIRECT NAME)");})

#define NUPLEP(where) (INDIC_SELECT_NAT(where->indic) == N_TUPLE && \
		       RD_SORT(INDIC_SELECT_SORT(where->indic)) >= MIN_SORT &&\
		       RD_SORT(INDIC_SELECT_SORT(where->indic)) % 2 == 0)

#define C_NUPLEP(where) (INDIC_SELECT_NAT(where->indic) == N_TUPLE && \
		       RD_SORT(INDIC_SELECT_SORT(where->indic)) >= MIN_SORT &&\
		       RD_SORT(INDIC_SELECT_SORT(where->indic)) % 2 == 1)

#define UNKP(where) (INDIC_SELECT_NAT(where->indic) == N_UNK && \
		     RD_SORT(INDIC_SELECT_SORT(where->indic)) >= MIN_SORT && \
		     RD_SORT(INDIC_SELECT_SORT(where->indic)) % 2 == 0)

#define UNK_CTRP(where) (INDIC_SELECT_NAT(where->indic) == N_UNK_CTR && \
		     RD_SORT(INDIC_SELECT_SORT(where->indic)) >= MIN_SORT && \
		     RD_SORT(INDIC_SELECT_SORT(where->indic)) % 2 == 0)

#define SUBSTP(where) (INDIC_SELECT_NAT(where->indic) == N_SUBST && \
		       RD_SORT(INDIC_SELECT_SORT(where->indic)) >= MIN_SORT &&\
		       RD_SORT(INDIC_SELECT_SORT(where->indic)) % 2 == 1)

#define NILP(where) (where->indic == IND_NIL)
#define NODEP(where) (where->indic == IND_NODE)
#define FF_EMPTYP(where) (where->indic == IND_FF_EMPTY)
#define TRUEP(where) (where->indic == IND_TRUE)
#define FF_PAIRP(where) (where->indic == IND_FF_PAIR)
#define FF_LISTP(where) (where->indic == IND_FF_LIST)
#define UVAR_REPLP(where) (where->indic == IND_UVAR_REPL)
#define VAR_UVAR(where) (where->indic == IND_VAR_UVAR)
#define FR_LISTP(where) (where->indic == IND_FR_LIST)
#define UN_PBP(where) (where->indic == IND_UN_PB)
#define GOALP(where) (where->indic == IND_GOAL)
#define FULL_GOALP(where) (where->indic == IND_FULL_GOAL)
#define LDISPLAP(where) (where->indic == IND_LDISPLA)
#define DISPLAP(where) (where->indic == IND_DISPLA)
#define CONS_DISPLAP(where) (where->indic == IND_CONS_DISPLA)
#define EGSP(where) (where->indic == IND_EGS)
#define LBD_CTXP(where) (where->indic == IND_LBD_CTX)
#define REFP(where) ((where)->indic == IND_REF)
#define CHPTP(where) (where->indic == IND_CHPT)
#define STRINGP(where) (where->indic == IND_STRING)
#define INTEGERP(where) (where->indic == IND_INTEGER)
#define FLOATP(where) (where->indic == IND_FLOAT)
#define SYMBP(where) (where->indic == IND_SYMB)
#define T_ARROWP(where) (where->indic == IND_T_ARROW)
#define T_UNKP(where) (where->indic == IND_T_UNK)
#define T_SYMBP(where) (where->indic == IND_T_SYMB)
#define T_APPL1P(where) (where->indic == IND_T_APPL1)
#define T_NUPLEP(where) (where->indic == IND_T_NUPLE)
#define VARP(where) (where->indic == IND_VAR)
#define HAT_FGP(where) (where->indic == IND_HAT_FG)
#define VARAP(where) (where->indic == IND_VARA)
#define UVARP(where) (where->indic == IND_UVAR)

#define CONSP(where) (where->indic == IND_CONS || where->indic == IND_C_CONS)
#define APPL1P(where) (where->indic == IND_APPL1 || where->indic ==IND_C_APPL1)
#define APPLP(where) (where->indic == IND_APPL || where->indic == IND_C_APPL)
#define ABSTRP(where) ((RD_SORT(INDIC_SELECT_SORT(where->indic)) >> 2) == 1)
#define ETA_ABSTRP(where) (where->indic == IND_ETA_ABSTR || where->indic ==IND_C_ETA_ABSTR)

#define NUPLE_GET_SIZE(robj) TUPLE_GET_SIZE(robj)

#define T_NUPLE_GET_SIZE(robj) TUPLE_GET_SIZE(robj)

#define T_APPL1_GET_ARITY(robj) (TUPLE_GET_SIZE(robj) - 1)

#define INIT_DSYMB(Dsymb, Symb) Dsymb.symb = (psymbT*)&Symb;

#define HO(term) ((RD_SORT(INDIC_SELECT_SORT(term->indic)) >> 3) == 0)

#define MATCH() (control.unif_state.match.indic != IND_NIL)
#define DEFREEZE() (control.unif_state.defreeze.indic != IND_NIL)
#define MATCH_OR_DEFREEZE() (MATCH() || DEFREEZE())



#define RD_ABSTRx(where, var_robj) RD_TUPLEx(where, *var_robj)
#define RD_APPLx(where, var_robj) RD_TUPLEx(where, *var_robj)
#define MK_NILx(where) MK_CONS0x(SORT_NIL, where)
#define MKA_NILx(num_arg) MKA_w_a(MK_NILx, num_arg)
#define MK_CONSx(where, var_robj) MK_CONS2x(SORT_CONS, where, *var_robj)
#define RD_CONSx(where, var_robj) RD_CONS2x(where, *var_robj)
#define MK_C_CONSx(where, var_robj) MK_CONS2x(SORT_C_CONS, where, *var_robj)
#define MKA_CONSx(num_arg, var_robj) MKA_w_a_o(MK_C_CONSx, num_arg, var_robj)
#define MK_UNKNx(where, num_unk) ST_CELLx(where, &rr[num_unk])
#define MKA_UNKNx(num_arg, num_unk) MKA_w_a_u(MK_UNKNx, num_arg, num_unk)
#define ST_TYPEx(num_reg, num_arg) ASSIGN_P2_TO_P1(rr[num_reg], *REG_TYPE(num_arg))


#ifdef DBUG
#define ST_TYPE(num_reg, num_arg) ST_TYPEi(num_reg, num_arg) 
#define RD_ABSTR(where, var_robj) RD_ABSTRi(where, var_robj) 
#define RD_APPL(where, var_robj) RD_APPLi(where, var_robj)
#define MK_NIL(where) MK_NILi(where)
#define MKA_NIL(num_arg) MKA_NILi(num_arg)
#define MK_CONS(where, var_robj) MK_CONSi(where, var_robj)
#define RD_CONS(where, var_robj) RD_CONSi(where, var_robj)
#define MK_C_CONS(where, var_robj) MK_C_CONSi(where, var_robj)
#define MKA_CONS(num_arg, var_robj) MKA_CONSi(num_arg, var_robj)
#define MK_UNKN(where, num_unk) MK_UNKNi(where, num_unk)
#define MKA_UNKN(num_arg, num_unk) MKA_UNKNi(num_arg, num_unk)
#else
#define ST_TYPE(num_reg, num_arg) ST_TYPEx(num_reg, num_arg) 
#define RD_ABSTR(where, var_robj) RD_ABSTRx(where, var_robj) 
#define RD_APPL(where, var_robj) RD_APPLx(where, var_robj) 
#define MK_NIL(where) MK_NILx(where)
#define MKA_NIL(num_arg) MKA_NILx(num_arg)
#define MK_CONS(where, var_robj) MK_CONSx(where, var_robj)
#define RD_CONS(where, var_robj) RD_CONSi(where, var_robj)
#define MK_C_CONS(where, var_robj) MK_C_CONSx(where, var_robj)
#define MKA_CONS(num_arg, var_robj) MKA_CONSx(num_arg, var_robj)
#define MK_UNKN(where, num_unk) MK_UNKNx(where, num_unk)
#define MKA_UNKN(num_arg, num_unk) MKA_UNKNx(num_arg, num_unk)
#endif
/****************************************************************************
% PM        file : control.h (9/23/93)
%
%     AUTHOR
%          IRISA/INRIA/Universite de Rennes I/INSA de Rennes/CNRS
%            35042 Rennes Cedex - France
%          Phone : (33) 99 84 71 00       Fax : (33) 99 38 38 32
%
%     This software has been designed and programmed by P Brisset & O Ridoux
%     at IRISA. For further information or comments email :  pm@irisa.fr or
%     write to IRISA (Institut de Recherche en Informatique et Syste`mes
%     Ale'atoires)
%
%     COPYRIGHT
%          Both this software PM and its documentation are
%
%              Copyrighted 1992 by IRISA
%                         all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : Licensing).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and IRISA is NOT affiliated with that organization.
******************************************************************************/
#define rr      control.regs.r
#define in      control.regs.r
#define out     control.regs.s
#define REG_TYPE(X)      (&(control.regs.t[X]))
#define aa     control.regs.a
#define xx     control.robj.x
#define lbd    control.robj.l
#define gg     control.robj.g
/*** changement de nom pour eviter des confusions dans des bloc C citant des
  variables Prolog (X) ***/


/****** stateT       */
#define CHPT_TRY    1
#define CHPT_RETRY  2

/* Makes an entry value
******* entryT  ( unsigned long ) */
#define MK_ENTRY( val           ) (entryT)val

/* Selects the right entry according to the search state.
******* Switch      () */
#define SelectEntry()       switch (control.chpt.entry)

/* Declares an entry
******* Case ( unsigned long) */
#define PM_ENTRY( num_entry    )    case MK_ENTRY(num_entry)

/* Fails inside a predicate.
******* Exec     */
#define FAIL_IN() \
{ DO_FAIL_IN() ; goto loop; }

/* Fails outside a predicate.
******* Exec      */
#define FAIL_OUT() \
{ DO_FAIL_OUT() ; return; }


#define FailWithIndexing() {if (control.chpt.entry == 0) FAIL_OUT();}

/* Tests unifiability for predicates with only one clause.
******* Exec       ( boolT ) */
#define FailUnless( unif  ) \
{ \
  if ((unif) && FINISH_UNIFY()) { COMMIT_CHOICE(); } else { FAIL_OUT() ; }; \
}

#define RecordFail() ASSIGN_P2_TO_P1(control.level.cut, *(control.level.top));
#define RecordTrust() RecordFail()
#define SetChptDone(val) control.chpt.done = val;

/* Instals a choice point.
******* Exec       (boolT) */
#define TryMeElse(unif) \
{ \
  if ((unif) && FINISH_UNIFY()) { COMMIT_CHOICE(); } else { FAIL_IN(); }; \
}

#define RecordTry(entry_else) control.chpt.state = CHPT_TRY; \
                              control.chpt.entry = entry_else;
                         

/* Uses and updates a choice point.
******* Exec         (boolT) */
#define RetryMeElse(unif) \
{ \
  if ((unif) && FINISH_UNIFY()) { COMMIT_CHOICE(); } else { FAIL_IN(); } \
}

#define RecordRetry(entry_else) control.chpt.entry = entry_else;


/* Loops in a left-recursive predicate.
******* Exec */
#define LOOP() { if (MATCH_OR_DEFREEZE()) \
		   { PUSH_FIRST_GOAL(); DO_DEFREEZE_AND_MATCH(); return;} \
                 else {DO_LOOP(); goto loop;} }
 
/* Continues after a fact.  Fetchs in the goal statement the next predicate
** to execute.
******* Exec */
#define CONTINUE() { if (MATCH_OR_DEFREEZE()) \
		       {DO_DEFREEZE_AND_MATCH();} \
                     else {DO_CONTINUE();} \
		     return ; }
 
/* Executes the next predicate.  It is associated to the first goal of the 
** body.
******* Exec */
#define EXECUTE(symb) { control.pred.p = (psymbT*)symb; \
			if (MATCH_OR_DEFREEZE()) \
		     { PUSH_FIRST_GOAL(); DO_DEFREEZE_AND_MATCH();} \
                    else {DO_EXECUTE();} \
		    return; }
		      

 
/****************************************************************************
% PM        file : param.h (5/19/92)
%
%     AUTHOR
%          IRISA/INRIA/Universite de Rennes I/INSA de Rennes/CNRS
%            35042 Rennes Cedex - France
%          Phone : (33) 99 84 71 00       Fax : (33) 99 38 38 32
%
%     This software has been designed and programmed by P Brisset & O Ridoux
%     at IRISA. For further information or comments email :  pm@irisa.fr or
%     write to IRISA (Institut de Recherche en Informatique et Syste`mes
%     Ale'atoires)
%
%     COPYRIGHT
%          Both this software PM and its documentation are
%
%              Copyrighted 1992 by IRISA
%                         all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : Licensing).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and IRISA is NOT affiliated with that organization.
******************************************************************************/
#define MAX_NB_VARGS     260
#define MAX_NB_VTYPES    130
#define MAX_NB_OBJS      2*MAX_NB_VARGS
#define MAX_NB_LBDS      100
#define NB_DYN_FACTS     23L
#define GC_SIZE          (1L /* goal statement */ \
			+ 1L)
#define CHPT_SIZE        (1L /* goal statement */ \
			+ 1L /* predicate address */ \
			+ 1L /* clause number */ \
			+ 1L) /* dynamic facts */
/****************************************************************************
% PM        file : unif1.h (9/2/92)
%
%     AUTHOR
%          IRISA/INRIA/Universite de Rennes I/INSA de Rennes/CNRS
%            35042 Rennes Cedex - France
%          Phone : (33) 99 84 71 00       Fax : (33) 99 38 38 32
%
%     This software has been designed and programmed by P Brisset & O Ridoux
%     at IRISA. For further information or comments email :  pm@irisa.fr or
%     write to IRISA (Institut de Recherche en Informatique et Syste`mes
%     Ale'atoires)
%
%     COPYRIGHT
%          Both this software PM and its documentation are
%
%              Copyrighted 1992 by IRISA
%                         all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : Licensing).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and IRISA is NOT affiliated with that organization.
******************************************************************************/

#define NB_HOLES control.unif_state.nb_open_pars
#define NB_HOLES_T control.unif_state.nb_open_pars_t

/* "num_arg" contient le numero de l'argument ou se trouve le terme statique.
*/

/****** boolT      ( long,  numT    ) */   
#define UNA_INTEGER( value, num_arg ) ( UNR_INTEGER( value, &(rr[num_arg]) ) )

/****** boolT    ( float, numT    ) */   
#define UNA_FLOAT( value, num_arg ) ( UNR_FLOAT( value, &(rr[num_arg]) ) )

/****** boolT     ( char *, numT    ) */   
#define UNA_STRING( value,  num_arg ) ( UNR_STRING( value, &(rr[num_arg]) ) )

/****** boolT   ( symbT *, numT    ) */   
#define UNA_SYMB( value,   num_arg ) ( UNR_SYMB( value, &(rr[num_arg]) ) )

/****** boolT    ( fsymbT *, numT,    T_ROBJ * ) */   
#define UNA_APPL1( functor,  num_arg, var_robj  ) ( UNR_C_APPL1( functor, &(rr[num_arg]), var_robj ) )

/****** boolT   ( numT,    T_ROBJ * ) */   
#define UNA_CONS( num_arg, var_robj  ) ( UNR_C_CONS( &(rr[num_arg]), var_robj ) )

/****** boolT   ( numT,    T_ROBJ * ) */   
#define UNA_SUBST( num_arg, var_robj  ) ( UNR_SUBST( &(rr[num_arg]), var_robj ) )

/****** boolT   ( T_SORT, numT,    T_ROBJ *, numT ) */ 
#define UNA_NUPLE( sort, num_arg, var_robj, length) UNR_NUPLE(sort, &(rr[num_arg]), var_robj, length)

/****** boolT  ( numT    ) */   
#define UNA_NIL( num_arg ) ( UNR_NIL( &(rr[num_arg]) ) )

/****** boolT  ( numT    ) */   
#define UNA_CUT( num_arg ) ( UNR_CUT( &(rr[num_arg]) ) )

/****** boolT   ( numT) */   
#define UNA_VOID( num_arg) ( /* UNR_VOID( &(rr[num_arg]), 1 ) */ trueC )

/****** boolT   ( numT,    numT    ) */   
#define UNA_UNK1( num_arg, num_unk ) (UNR_UNK1(&(rr[num_arg]), num_unk), trueC)

/****** boolT   ( numT,    numT    ) */    
#define UNA_UNKN( num_arg, num_unk ) ( UNR_UNKN( &(rr[num_arg]), num_unk ) )

/****** boolT   ( numT,    numT    ) */   
#define UNA_REF1( num_arg, num_ref ) (UNR_REF1(&(rr[num_arg]), num_ref), trueC)

/****** boolT   ( numT,    numT    ) */    
#define UNA_REFN( num_arg, num_ref ) ( UNR_REFN( &(rr[num_arg]), num_ref ) )

#define RD_MODE() (control.unif_state.nb_open_pars == 0L)

#define UNR_UNK1x(where, num_unk) (rr[num_unk].info = (where)->info, rr[num_unk].indic = (where)->indic, trueC)
#define UNW_UNKNx(where, num_unk) ((where)->info = rr[num_unk].info, (where)->indic = rr[num_unk].indic, NB_HOLES--, trueC)
#define UNW_UNK1x(where, num_unk) (MK_UNK1(where, num_unk), NB_HOLES--, trueC)

#ifdef DBUG
#define UNR_UNK1(where, num_unk) UNR_UNK1i(where, num_unk) 
#define UNW_UNKN(where, num_unk) UNW_UNKNi(where, num_unk) 
#define UNW_UNK1(where, num_unk) UNW_UNK1i(where, num_unk) 
#else
#define UNR_UNK1(where, num_unk) UNR_UNK1x(where, num_unk)
#define UNW_UNKN(where, num_unk) UNW_UNKNx(where, num_unk) 
#define UNW_UNK1(where, num_unk) UNW_UNK1x(where, num_unk) 
#endif

#define UN_UNK1(where, num_unk, mk_type) ((RD_MODE() ? \
					  UNR_UNK1(where, num_unk) : \
					  (UNW_UNK1(where, num_unk), mk_type)), trueC)


typedef int bool3T;
#define safeC ((bool3T)1)
#define unsafeC ((bool3T)2)
#define unknownC ((bool3T)3)
/****************************************************************************
% PM        file : type.h (7/14/93)
%
%     AUTHOR
%          IRISA/INRIA/Universite de Rennes I/INSA de Rennes/CNRS
%            35042 Rennes Cedex - France
%          Phone : (33) 99 84 71 00       Fax : (33) 99 38 38 32
%
%     This software has been designed and programmed by P Brisset & O Ridoux
%     at IRISA. For further information or comments email :  pm@irisa.fr or
%     write to IRISA (Institut de Recherche en Informatique et Syste`mes
%     Ale'atoires)
%
%     COPYRIGHT
%          Both this software PM and its documentation are
%
%              Copyrighted 1992 by IRISA
%                         all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : Licensing).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and IRISA is NOT affiliated with that organization.
******************************************************************************/
/* TYPES */

#include <setjmp.h>

typedef unsigned long arityT ;
typedef unsigned long numT ;

typedef long boolT ;
#define trueC ((boolT)(0==0))
#define falseC ((boolT)(0!=0))

typedef void predT() ;

typedef struct { char *name; arityT arity, t_arity; predT *type; } symbT ;
/* UPD TYPE tsymbT */
typedef struct { char *name; arityT arity; } tsymbT ;
typedef struct psymbT_ { char *name; arityT arity, t_arity;
			 predT *type, *pred;
			 struct psymbT_ *stop_in;
			 int stop_in_num, hid_num;
			 struct psymbT_ *hidden;
		       }                               psymbT ;
typedef struct dsymbT_ { char *name;  /*** always NULL ***/
			 arityT arity, t_arity; /* to have one single MK_GOAL */
			 int lineno;
			 char *filename;
			 psymbT *symb;
			 char *time;
		       }                         dsymbT;

typedef struct disunkT_ { char *name;
			  int index;
			  struct disunkT_ *display;
			  int num;
			  char *pred_name;
			}                     disunkT;
		 

#define nil_psymbT ((psymbT*)0L)
#define nil_dsymbT ((dsymbT*)0L)
#define nil_disunkT ((disunkT*)0L)
#define SU_VAR(REF_CELL, REF_OBJ) SU_MUT(REF_CELL, REF_OBJ)
#define VAR_SELECT_VALUE(REF_CELL) MUT_SELECT_VALUE(REF_CELL)

#define MAX_ABSTR 50
#define MAX_NB_PAIRS 50

typedef
struct {
  unsigned long nb_pages_in, low_water, high_water, page_size, overflow; 
} pm_allocT ; 

typedef struct {
  pm_allocT      alloc ; 
  struct {
    jmp_buf        process ;
    boolT          trace_on, warning_on, error_on, dbug_on;
  }              xcep ; 
  struct {
    boolT          type;
  }              print;
  struct {
    boolT          on;
  }              gc;
} pmT ;

typedef int entryT;

typedef unsigned long stateT ;

typedef struct 
{ struct 
  { T_CELL      r[MAX_NB_VARGS] ;   /* Registers for holding variables during 
                                   ** the handling of ONE clause,
                                   ** and for holding arguments of the head 
                                   ** and the first goal (and variables that 
                                   ** are arguments) during the handling of 
                                   ** ONE clause */
    T_CELL      s[MAX_NB_VARGS] ;    /*** for outs of C_blocks ***/
    T_CELL      t[MAX_NB_VTYPES];    /* For types */
    T_CELL      dyn_facts;           /*** for implication ***/

  }          regs ;
  struct 
  { T_ROBJ    x[MAX_NB_OBJS] ;    /* Registers for holding references to 
                                   ** created or traversed objects */
    T_ROBJ    l[MAX_NB_LBDS] ;  
    T_ROBJ    g              ;    /* Register for holding the reference to the
                                   ** created goals (one at a time),
                                   ** and the reference to the goal in the 
                                   ** top-level */
    T_ROBJ    unk_robj;
  }          robj ;
  struct
  { arityT     nb_args ;           /* Says how many arguments must be in 
                                   ** registers */
    T_CELL *    where ;             /* Where to plug a goal */
    T_CELL      gs    ;             /* The next remaining goal statement */
  }          body ;
  struct 
  { psymbT   * p ;                 /* Pointer to the current predicate */
    T_CELL      gs ;                /* The remaining goal statement */
  }          pred ;
  struct 
  { boolT      done ; 
    stateT     state ; 
    entryT     entry ;             /* Entry in the current predicate: at first
                                   ** encounter it is 1L (one), then it is as
                                   ** specified by the control */
    T_ROBJ    root ;
  }          chpt ;              /* For lazy choice-point creation */
  struct 
  { T_CELL      cut,                /* The target level for the cut */
             *top ;               /* The top level.  Points to a register in
                                   ** MALIv06 */
  }          level ;    
  struct {
    unsigned long nb_open_pars;
    unsigned long nb_open_pars_t;
    /*** initialise' une fois pout toute : le compteur revient a` ze'ro a`
      chaque sortie du mode e'criture. Or on sort toujours du mode e'criture
      car il ne peut pas e'chouer ***/
    T_CELL match; /*** contient la FR_LIST des UN_PB flexibles rigides :
			doit etre teste dans la continuation afin de fabriquer
			un but match ***/
    T_CELL defreeze; /*** contient la liste des buts de'gele's :
			doit etre teste dans la continuation afin de re'activer
			ces buts ***/
    unsigned long nb_pairs;
    T_CELL pair1[MAX_NB_PAIRS], pair2[MAX_NB_PAIRS];
    T_CELL ctx1[MAX_NB_PAIRS], ctx2[MAX_NB_PAIRS];
    int pilev[MAX_NB_PAIRS];
  } unif_state; 
  struct {
    int level;                 /*** for creation of UNK under pi ***/
  } pi;
  struct {
    T_CELL cell_table[MAX_ABSTR];
  } reduce;
} controlT ;

/****************************************************************************
% PM        file : state.h (5/19/92)
%
%     AUTHOR
%          IRISA/INRIA/Universite de Rennes I/INSA de Rennes/CNRS
%            35042 Rennes Cedex - France
%          Phone : (33) 99 84 71 00       Fax : (33) 99 38 38 32
%
%     This software has been designed and programmed by P Brisset & O Ridoux
%     at IRISA. For further information or comments email :  pm@irisa.fr or
%     write to IRISA (Institut de Recherche en Informatique et Syste`mes
%     Ale'atoires)
%
%     COPYRIGHT
%          Both this software PM and its documentation are
%
%              Copyrighted 1992 by IRISA
%                         all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : Licensing).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and IRISA is NOT affiliated with that organization.
******************************************************************************/
extern controlT    control ;
extern pmT         pm ;
/****************************************************************************
% PM        file : reduce.h (10/6/92)
%
%     AUTHOR
%          IRISA/INRIA/Universite de Rennes I/INSA de Rennes/CNRS
%            35042 Rennes Cedex - France
%          Phone : (33) 99 84 71 00       Fax : (33) 99 38 38 32
%
%     This software has been designed and programmed by P Brisset & O Ridoux
%     at IRISA. For further information or comments email :  pm@irisa.fr or
%     write to IRISA (Institut de Recherche en Informatique et Syste`mes
%     Ale'atoires)
%
%     COPYRIGHT
%          Both this software PM and its documentation are
%
%              Copyrighted 1992 by IRISA
%                         all rights reserved.
%
%          Permission is granted to copy, use, and distribute
%          for any commercial or noncommercial purpose under the terms
%          of the GNU General Public license, version 2, June 1991
%          (see file : Licensing).
%
%          NOTE :
%          This software has not been endorsed by the Free Software Foundation,
%          ( 675 Mass Ave, Cambridge, MA 02139, USA ),
%          the creator of the GNU license,
%          and IRISA is NOT affiliated with that organization.
******************************************************************************/
#define REDUCE(term) {reduce(term); RD_DIREC(term);}
#define STRONG_REDUCE(term, gc) {strong_reduce(term, gc); RD_DIREC(term);}

